﻿Public Class Form1

    Dim RandomNumber As String = ""     '以字串方式記錄的隨機數
    Dim Stage As Integer = 3           '用以記錄難度的變量，亦即每次顯示數字的數目
    Dim Count3 As Integer = 3           '用以作3秒倒數的變量
    Dim WaitInterval As Integer = 500   '顯示隨機數的時間(以微秒ms為單位)

    '處理"Start"按鈕的程序，主要用以啟動3秒倒數
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button1.Enabled = False
        Timer1.Enabled = True
        Timer1.Start()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Randomize()     '初始化隨機數
    End Sub

    'Timer1用以控制顯示數目前的三秒倒數
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        TextBox1.Text = "Get Ready!"
        '以不同顏色顯示倒數的數值
        If Count3 = 3 Then
            Label1.ForeColor = Color.Red
        ElseIf Count3 = 2 Then
            Label1.ForeColor = Color.Yellow
        ElseIf Count3 = 1 Then
            Label1.ForeColor = Color.LightGreen
        Else
            Label1.ForeColor = Color.Aquamarine
        End If
        Label1.Text = Count3
        Count3 -= 1
        '倒數完結時，中止Timer1(停止三秒倒數)並啟動Timer2
        If Count3 < 0 Then
            Timer1.Stop()
            Timer1.Enabled = False
            Timer2.Enabled = True
            Timer2.Start()
            MakeNumberString()
            Label1.Text = RandomNumber
            Count3 = 2
        End If

    End Sub

    '用以清除顯示於畫面內的隨機數，隨機數的顯示時間視乎 Timer2.Interval 
    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick

        Count3 -= 1
        If Count3 = 0 Then
            Timer2.Stop()
            Timer2.Enabled = False
            TextBox1.Enabled = True
            TextBox1.Focus()
            TextBox1.Text = ""
            Label1.Text = ""
            Count3 = 3
        End If

    End Sub

    '按結束按鈕終結整個程式
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        End
    End Sub


    '用以產生隨機數的程序
    Private Sub MakeNumberString()
        RandomNumber = ""
        For i As Integer = 1 To Stage
            RandomNumber = RandomNumber & Int(Rnd() * 10)
        Next
    End Sub

    '用以控制遊戲難度的程序，每次執行時，都會把隨機數的數字數目加一
    '直至隨機數有15個數字時，顯示數字的時間便會縮短，最短時限為0.1秒
    Private Sub SetGameDifficulty()

        If Stage < 15 Then      '檢查隨機數的數字數是否小於15
            Stage = Stage + 1
        Else         ' 若隨機數的數字小於15便縮短顯示時限提高難度
            If WaitInterval > 100 Then
                WaitInterval -= 50
                Timer2.Interval = WaitInterval
            End If
        End If

    End Sub

    '用以核對隨機數與輸入數值是否相同函數：
    '
    Private Function CheckAnswer() As Boolean

        If TextBox1.Text = RandomNumber Then
            Return True
        End If

        Return False

    End Function

    '當使用者於TextBox1內按鍵盤的事件處理程序
    Private Sub TextBox1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        '檢查使用者有否輸入任何數值及按"Enter"按鈕
        If TextBox1.Text <> "" And e.KeyCode = Keys.Enter Then
            If CheckAnswer() Then   '檢查答案是否正確，若果正確...
                Label1.ForeColor = Color.LightCyan
                Label1.Text = "Correct!!!"
                SetGameDifficulty() '提高遊戲難度
            Else    '答案不正確
                Label1.ForeColor = Color.Red
                Label1.Text = "Wrong!!!"
            End If
            TextBox1.Enabled = False
            TextBox1.Text = "Get Ready!"
            Me.Focus()
            Timer1.Enabled = True   '重新開始三秒倒數
            Timer1.Start()
        End If
    End Sub

End Class

